struct key_desc {
	char * label;
	int row;
	int column;
        union {
          struct {
            u8 x;
            u8 y;
            u8 w;
            u8 h;
            u8 c;
          };
	  u8 shortcut[5];
        };
	const u8 *pcx;
} labels[NBUTTONS] = {
	{"F1",6,4, {0,0}, f1_pcx},
	{"F2",6,3, {0,0}, f2_pcx},
	{"F3",6,2, {0,0}, f3_pcx},
	{"F4",6,1, {0,0}, f4_pcx},
	{"F5",6,0, {0,0}, f5_pcx},

	{"2nd",6,5,{0,0}, _2nd_pcx},
	{"EXIT",6,6,{0, 0}, exit_pcx},
	{"MORE",6,7, {0,0}, more_pcx},
	{"<",0,1, {0,0}, left_pcx},
	{"^",0,3, {0,0}, up_pcx},

	{"ALPHA",5,7,{0,0}, alpha_pcx},
	{"x-VAR",4,7,{'`', 0}, xvar_pcx},
	{"DEL",3,7,{0, 0, 0}, del_pcx},
	{"v",0,0,{0, 0}, down_pcx},
	{">",0,2,{0, 0}, right_pcx},

	{"GRAPH",5,6, {0, 0}, graph_pcx},
	{"STAT",4,6, {0, 0}, stat_pcx},
	{"PRGM",3,6, {0, 0}, prgm_pcx},
	{"CUSTOM",2,6, {0, 0}, custom_pcx},
	{"CLEAR",1,6, {0, 0}, clear_pcx},

	{"LOG",5,5, {'a', 0}, log_pcx},
	{"SIN",4,5, {'b', 0}, sin_pcx},
	{"COS",3,5, {'c', 0}, cos_pcx},
	{"TAN",2,5, {'d', 0}, tan_pcx},
	{"^",1,5, {'e', 0, 0}, powerby_pcx},

	{"LN",5,4, {'f', 0}, ln_pcx},
	{"EE",4,4, {'g', 0}, ee_pcx},
	{"(",3,4, {'h',0, 0}, parleft_pcx},
	{")",2,4, {'i',0, 0}, parright_pcx},
	{"/",1,4, {'j','/', 0}, div_pcx},

	{"x^2",5,3, {'k', 0}, power2_pcx},
	{"7",4,3, {'7',0,'l', 0}, seven_pcx},
	{"8",3,3, {'8',0,'m', 0}, eight_pcx},
	{"9",2,3, {'9',0,'n', 0}, nine_pcx},
	{"*",1,3, {0,'o', 0}, mul_pcx},

	{",",5,2, {',','p', 0}, comma_pcx},
	{"4",4,2, {'4',0,'q', 0}, four_pcx},
	{"5",3,2, {'5',0,'r', 0}, five_pcx},
	{"6",2,2, {'6',0,'s', 0}, six_pcx},
	{"-",1,2, {'-','t', 0}, minus_pcx},

	{"STO>",5,1, {0,'=', 0}, sto_pcx},
	{"1",4,1, {'1',0,'u', 0}, one_pcx},
	{"2",3,1, {'2',0,'v', 0}, two_pcx},
	{"3",2,1, {'3',0,'w', 0}, three_pcx},
	{"+",1,1, {0, 0}, plus_pcx},

	{"ON",5,0, {0, 0}, on_pcx},
	{"0",4,0, {'0',0,'y', 0}, zero_pcx},
	{".",3,0, {'.','z', 0}, dot_pcx},
	{"-",2,0, {' ','\\', 0}, sign_pcx},
	{"ENTER",1,0, {0, 0, 0}, enter_pcx},
	{"SAVE",-1,KEY_SAVE, {0, 0, 0}, save_pcx},
	{"LOAD",-1,KEY_LOAD, {0, 0, 0}, load_pcx},
	{"RESET",-1,KEY_RESET, {0, 0, 0}, reset_pcx},
	{"SIZE",-1,KEY_SIZE, {0, 0, 0}, size_pcx},
	{"SPEED",-1,KEY_SPEED, {0, 0, 0}, real_pcx},
	{"GFX",-1,KEY_GFX, {0, 0, 0}, gfast_pcx},
	{"SEND",-1,KEY_SEND, {0, 0, 0}, send_pcx}
};

for(i=0; i<NBUTTONS; i++)
    {
	if (i/5 == 0){
            labels[i].x = 51*i+7  -45;
            labels[i].y = 54;
            labels[i].w = 42;
            labels[i].h = 20;
        }
        else if (i == 8){
            labels[i].x = 102;
            labels[i].y = 80+3+9;
            labels[i].w = 16;
            labels[i].h = 16;
        }
        else if (i == 9){
            labels[i].x = 102+18;
            labels[i].y = 80+3;
            labels[i].w = 16;
            labels[i].h = 16;
        }
        else if (i == 13){
            labels[i].x = 102+18;
            labels[i].y = 80+3+18;
            labels[i].w = 16;
            labels[i].h = 16;
        }
        else if (i == 14){
            labels[i].x = 102+36;
            labels[i].y = 80+3+9;
            labels[i].w = 16;
            labels[i].h = 16;
        }
        else if(i<50){
            labels[i].x = (i%5)*32;
            labels[i].y = 64+6+(i/5)*17;
            labels[i].w = 28;
            labels[i].h = 12;
        }
        else
        {
            labels[i].x = -45+  225;
            labels[i].y = 52+  40 + (i-50)*20;
            labels[i].w = 28;
            labels[i].h = 12;
        }
        labels[i].y -= 52;
        labels[i].x += 45;
    }
